/*
gnaughty - porn movie downloader
Copyright (C) 2002 David Moore

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
*/

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <gtk/gtk.h>
#include "parselinks.h"

#ifdef HAVE_PCRE_H
#include <pcre.h>
#else
#ifdef HAVE_PCRE_PCRE_H
#include <pcre/pcre.h>
#else
#error pcre not found
#endif
#endif

GString* cutsublimepage(GString *page)
{
	GString *newstr;
	gchar *start;
	gchar *end;
	int len;
	
	if (strcmp(page->str, "") == 0) {
		return NULL;
	}
	if ( (start=strstr(page->str, "open it in a new window")) != NULL) {
 		if ( (end=strstr(start, "Our Running Archive:")) != NULL) {
 			len=(end-start)/sizeof(gchar);
 			newstr=g_string_new_len(start, len);
 			g_string_free(page, TRUE);
 			return newstr;
 		} else {
 			return NULL;
 		}
 	} else {
 		return NULL;
 	}
}

GList* getsublimelinks(GString *page)
{
	//stuff for linked list
	GList* links = NULL;
	
	//for parsing
	gchar *parsestr;
	gchar *pos;
	gchar *end;
	
	link_t* curlink;
	GString *cururl;
	GString *curdesc;
	
	parsestr = g_strdup(page->str);
	pos = parsestr;
	
	while (1)
	{
		curlink = g_new0(link_t, 1);
		//if not found
		if ((pos=strstr(pos, "></strong> <a href=\"http://"))==NULL)
			break;
		else
			pos+=sizeof(gchar)*20;

		end=strstr(pos, "\">");
		
		cururl=g_string_new(g_strndup(pos, (end-pos)/sizeof(gchar)));
		
		pos=end;
		
		//get the description of that link
		if ((pos=strstr(pos, "</a> - "))==NULL)
			break;
		else
			pos+=7;
		if((end=strstr(pos, "<br>"))==NULL)
		{
			curdesc=g_string_new("");
			break;
		}
		curdesc=g_string_new(g_strndup(pos, (end-pos)/sizeof(gchar)));

		curlink->url=g_string_new(cururl->str);
		curlink->desc=g_string_new(curdesc->str);
		links=g_list_append(links, curlink);
		
		pos=end;
		
		g_string_free(cururl, TRUE);
		g_string_free(curdesc, TRUE);
	}
	g_free(parsestr);
	return links;
}

/**
 * Appends extra downloads (of type download_t) to 'list'.
 */
GList* get_links_from_page(GList* list, GString* page, GString* baseurl, gboolean ismovie)
{
	pcre *reg;
	const char *pcre_err;
	int re_vector[ 6 ], pcre_erroroff, re_result, reg_offset = 0;
	GString *exts_re;
	
	if(ismovie)
		exts_re = g_string_new( "<a\\s+href\\s*=\\s*\"*([^\"\\s>]+\\.(?:" MOVIEEXTS "))\"*\\s*" );
	else
		exts_re = g_string_new( "<a\\s+href\\s*=\\s*\"*([^\"\\s>]+\\.(?:" PICTEXTS "))\"*\\s*" );
        
	reg = pcre_compile( exts_re->str, PCRE_CASELESS, &pcre_err, &pcre_erroroff, NULL );
	while( ( re_result = pcre_exec( reg, NULL, page->str, strlen( page->str ), reg_offset, 0, re_vector, 6 ) ) != -1 )
	{
		const char *string_pointer;
		download_t* new_download = NULL;
		new_download = g_malloc(sizeof(download_t));
		pcre_get_substring(page->str, re_vector, re_result, 1, &string_pointer );
		new_download->URL = gnaughty_urls_absolute_link(string_pointer, baseurl->str);
		new_download->status = STATUS_QUEUED;
		new_download->progress = 0.0;
		list = g_list_append(list, new_download);
		reg_offset = re_vector[ 1 ];
	}

	pcre_free( reg );
	g_string_free( exts_re, TRUE );

	return list;
}

void gnaughty_link_free(link_t* tobefreed)
{
	g_string_free(tobefreed->url, TRUE);
	g_string_free(tobefreed->desc, TRUE);
	g_free(tobefreed);
}
// vim:noexpandtab:ts=4 sw=4:
